{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Hist.TGraph2D.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Hist.TGraph2D.RawType
import HROOT.Hist.TGraph2D.FFI
import HROOT.Hist.TGraph2D.Interface
import HROOT.Hist.TGraph2D.Cast
import HROOT.Hist.TGraph2D.RawType
import HROOT.Hist.TGraph2D.Cast
import HROOT.Hist.TGraph2D.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITGraph2D (TGraph2D) where
        setN = xform1 c_tgraph2d_setn
        setPointXYZ = xform4 c_tgraph2d_setpointxyz

instance () => ITNamed (TGraph2D) where
        setName = xform1 c_tgraph2d_setname
        setNameTitle = xform2 c_tgraph2d_setnametitle
        setTitle = xform1 c_tgraph2d_settitle

instance () => ITAttLine (TGraph2D) where
        getLineColor = xform0 c_tgraph2d_getlinecolor
        getLineStyle = xform0 c_tgraph2d_getlinestyle
        getLineWidth = xform0 c_tgraph2d_getlinewidth
        resetAttLine = xform1 c_tgraph2d_resetattline
        setLineAttributes = xform0 c_tgraph2d_setlineattributes
        setLineColor = xform1 c_tgraph2d_setlinecolor
        setLineStyle = xform1 c_tgraph2d_setlinestyle
        setLineWidth = xform1 c_tgraph2d_setlinewidth

instance () => ITAttFill (TGraph2D) where
        setFillColor = xform1 c_tgraph2d_setfillcolor
        setFillStyle = xform1 c_tgraph2d_setfillstyle

instance () => ITAttMarker (TGraph2D) where
        getMarkerColor = xform0 c_tgraph2d_getmarkercolor
        getMarkerStyle = xform0 c_tgraph2d_getmarkerstyle
        getMarkerSize = xform0 c_tgraph2d_getmarkersize
        resetAttMarker = xform1 c_tgraph2d_resetattmarker
        setMarkerAttributes = xform0 c_tgraph2d_setmarkerattributes
        setMarkerColor = xform1 c_tgraph2d_setmarkercolor
        setMarkerStyle = xform1 c_tgraph2d_setmarkerstyle
        setMarkerSize = xform1 c_tgraph2d_setmarkersize

instance () => ITObject (TGraph2D) where
        clear = xform1 c_tgraph2d_clear
        draw = xform1 c_tgraph2d_draw
        findObject = xform1 c_tgraph2d_findobject
        getName = xform0 c_tgraph2d_getname
        isA = xform0 c_tgraph2d_isa
        paint = xform1 c_tgraph2d_paint
        printObj = xform1 c_tgraph2d_printobj
        saveAs = xform2 c_tgraph2d_saveas
        write = xform3 c_tgraph2d_write
        write_ = xform0 c_tgraph2d_write_

instance () => IDeletable (TGraph2D) where
        delete = xform0 c_tgraph2d_delete

newTGraph2D_ :: () => IO TGraph2D
newTGraph2D_ = xformnull c_tgraph2d_newtgraph2d_

newTGraph2D ::
              () =>
              CInt -> Ptr CDouble -> Ptr CDouble -> Ptr CDouble -> IO TGraph2D
newTGraph2D = xform3 c_tgraph2d_newtgraph2d

tGraph2D_GetXaxis :: () => TGraph2D -> IO TAxis
tGraph2D_GetXaxis = xform0 c_tgraph2d_tgraph2d_getxaxis

tGraph2D_GetYaxis :: () => TGraph2D -> IO TAxis
tGraph2D_GetYaxis = xform0 c_tgraph2d_tgraph2d_getyaxis

tGraph2D_GetZaxis :: () => TGraph2D -> IO TAxis
tGraph2D_GetZaxis = xform0 c_tgraph2d_tgraph2d_getzaxis

tGraph2D_SetMaximum :: () => TGraph2D -> CDouble -> IO ()
tGraph2D_SetMaximum = xform1 c_tgraph2d_tgraph2d_setmaximum

tGraph2D_SetMinimum :: () => TGraph2D -> CDouble -> IO ()
tGraph2D_SetMinimum = xform1 c_tgraph2d_tgraph2d_setminimum
